import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This generates LaTeX printouts of the partitions used
   in the calculations.  A1 is used for Calculations 1-8,
   and A2 is used for Calculation 11 and A4 is used for
   Calculation 12.*/


public class GenerateLatex {


    public static void main(Manager M) {
	Output OUT=new Output("texfile");
	printP1(OUT);
	printP2(OUT);
	printP4(OUT);
    }


    public static void printP1(Output OUT) {
	OUT.writeln("dogbone partition A1");
	for(int i=0;i<13;++i) {
          LongPolyhedron X0=DataPartition1.poly(i);
	  Integer I=new Integer(i);
	  String S="Q"+I.toString();
	  X0.texPrint(S,OUT);
	}
    }

    public static void printP2(Output OUT) {
	OUT.writeln("dogbone partition A2");
	for(int i=0;i<20;++i) {
          LongPolyhedron X0=DataPartition2.poly(i);
	  int q1=ProofSupport.insidePartition(X0);
	  LongPolyhedron X1=ProofSupport.dogboneMap(1,q1,X0);
	  int q2=ProofSupport.insidePartition(X1);
	  LongPolyhedron X2=ProofSupport.dogboneMap(1,q2,X1);
	  Integer Q1=new Integer(q1);
	  Integer Q2=new Integer(q2);
	  Integer I=new Integer(i);
	  String S="Q"+I.toString();
	  S=S+"("+Q1.toString()+","+Q2.toString()+")";
	  X0.texPrint(S,OUT);
	}
    }


    public static void printP4(Output OUT) {
	OUT.writeln("dogbone partition A4");
	for(int i=0;i<25;++i) {
          LongPolyhedron X0=DataPartition4.poly(i);





	  Integer I=new Integer(i);
	  String S="Q"+I.toString();
	  X0.texPrint(S,OUT);
	}
    }



}    










